<?php
	/*
	* ldap_abook plugin version 0.1
	*/

	define ('SM_PATH','../../');
	include_once (SM_PATH . 'include/validate.php');
	include_once (SM_PATH . 'functions/i18n.php');
	
	include_once (SM_PATH . 'plugins/ldap_abook/config.php');
	include_once (SM_PATH . 'plugins/ldap_abook/ldap_abook_class.php');
	include_once (SM_PATH . 'plugins/ldap_abook/ldap_gui.php');
	include_once (SM_PATH . 'plugins/ldap_abook/ldap_util.php');
	
	global $languages, $charset;
	
	$ldap_abook_user_prefs;

	bindtextdomain('ldap_abook', SM_PATH . 'plugins/ldap_abook/locale');
	textdomain('ldap_abook');

	getDisplayPageHeader(_('Address Book'));

	sqgetGlobalVar('PHP_SELF', $PHP_SELF, SQ_SERVER);
	sqgetGlobalVar('delete', $get_delete, SQ_GET);
	sqgetGlobalVar('modify', $get_modify, SQ_GET);
	sqgetGlobalVar('new', $get_new, SQ_GET);
	sqgetGlobalVar('search', $search, SQ_FORM);
	sqgetGlobalVar('delete', $post_delete, SQ_POST);
	sqgetGlobalVar('modify', $post_modify, SQ_POST);
	sqgetGlobalVar('new', $post_new, SQ_POST);
	sqgetGlobalVar('server', $server, SQ_FORM);
	sqgetGlobalVar('dn', $dn, SQ_FORM);
	sqgetGlobalVar('givenname', $givenname, SQ_FORM);
	sqgetGlobalVar('sn', $sn, SQ_FORM);
	sqgetGlobalVar('mail', $mail, SQ_FORM);
	sqgetGlobalVar('homephone', $homephone, SQ_FORM);
	sqgetGlobalVar('mobile', $mobile, SQ_FORM);
	sqgetGlobalVar('searchType', $type, SQ_FORM);
	sqgetGlobalVar('searchOrder', $order, SQ_FORM);

	if (!ldap_abook_loadPrefs())
		die(print '<h2>'._('No LDAP preferences defined').
		'!</h2><a href="'.SM_PATH.'src/options.php" style="font-size: 1.3em">'._('Set preferences').'</a>');
	if (!isset($search) && !isset($get_delete) &&
		!isset($get_modify) && !isset($get_new) &&
		!isset($post_delete) && !isset($post_modify) &&
		!isset($post_new))
		searchForm();
	else if (isset($get_delete)) {
		inputForm('delete', $server, $get_delete);		
	}
	else if (isset($get_modify)) {
		inputForm('modify', $server, $get_modify);
	}
	else if (isset($get_new)) {
		inputForm('new', $server, $get_new);
	}
	else if (isset($post_delete)) {
		$location = $dn;
		$conn = &new LdapInterface();
		$res = $conn->connect(
			$ldap_abook_user_prefs[$server]['host'],
			null,
			$ldap_abook_user_prefs[$server]['dn'],
			$ldap_abook_user_prefs[$server]['pwd']
		);
		if (LdapInterface::is_error($res)) 
			die(sprintf(_('Connect Error').
			' [%d]: %s<br/>host: %s<br/>dn: %s<br/>pwd: %s',
				$res->getCode(),$res->getMessage(),
				$ldap_abook_user_prefs[$server]['host'],
				$ldap_abook_user_prefs[$server]['dn'],
				$ldap_abook_user_prefs[$server]['pwd']
				));
		else {
			$res = $conn->delete($location);
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Update Error').
				' [%d]: %s<br/>dn: %s',
				$res->getCode(),$res->getMessage(),
				$location
				));
			else {
?>
      			<br/>
				<div style="text-align: center;">
					<h2><?php echo _('Address Book updated');?></h2>
					<a href="<?php echo $PHP_SELF ?>" style="font-size: 1.3em" target="_self"><?php echo _('Return');?></a>
				</div>
<?php
				$conn->close();
			}
		}		
	}
	else if (isset($post_modify)) {
		$location = $dn;
		$conn = &new LdapInterface();
		$res = $conn->connect(
			$ldap_abook_user_prefs[$server]['host'],
			null,
			$ldap_abook_user_prefs[$server]['dn'],
			$ldap_abook_user_prefs[$server]['pwd']
		);
		if (LdapInterface::is_error($res)) 
			die(sprintf(_('Connect Error').
			' [%d]: %s<br/>host: %s<br/>dn: %s<br/>pwd: %s',
				$res->getCode(),$res->getMessage(),
				$ldap_abook_user_prefs[$server]['host'],
				$ldap_abook_user_prefs[$server]['dn'],
				$ldap_abook_user_prefs[$server]['pwd']
				));
		else {
			$givenname = directory_string_convert($givenname, $server, 'LDAP');
			$sn = directory_string_convert($sn,	$server, 'LDAP');
			$info = array ('cn' => $givenname.' '.$sn,
						   'givenname' => $givenname,
						   'sn' => $sn,
					 	   'mail' => empty($mail)? ' ' : $mail,
					 	   'homephone' => empty($homephone)? ' ' : $homephone,
					 	   'mobile' => empty($mobile)? ' ' : $mobile,
					 	   'objectClass' => 'inetOrgPerson'
			);
			foreach ($info as $key => $val)
				$str_info .= $key.': '.$val.' ';
			$res = $conn->modify($location, $info);
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Update Error').
				' [%d]: %s<br/>dn: %s<br/>info: %s',
				$res->getCode(),$res->getMessage(),
				$location,
				$str_info
				));
			else {
?>
      			<br/>
				<div style="text-align: center;">
					<h2><?php echo _('Address Book updated');?></h2>
					<a href="<?php echo $PHP_SELF ?>" style="font-size: 1.3em" target="_self"><?php echo _('Return');?></a>
				</div>
<?php
				$conn->close();
			}
		}		
	}
	else if (isset($post_new)) {
		$location = $dn;
		$conn = &new LdapInterface();
		$res = $conn->connect(
			$ldap_abook_user_prefs[$server]['host'],
			null,
			$ldap_abook_user_prefs[$server]['dn'],
			$ldap_abook_user_prefs[$server]['pwd']
		);
		if (LdapInterface::is_error($res)) 
			die(sprintf(_('Connect Error').
			'[%d]: %s<br/>host: %s<br/>dn: %s<br/>pwd: %s',
				$res->getCode(),$res->getMessage(),
				$ldap_abook_user_prefs[$server]['host'],
				$ldap_abook_user_prefs[$server]['dn'],
				$ldap_abook_user_prefs[$server]['pwd']
				));
		else {
			$givenname = directory_string_convert($givenname, $server, 'LDAP');
			$sn = directory_string_convert($sn,	$server, 'LDAP');
			$info = array ('cn' => $givenname.' '.$sn,
						   'givenname' => $givenname,
						   'sn' => $sn,
					 	   'mail' => empty($mail)? ' ' : $mail,
					 	   'homephone' => empty($homephone)? ' ' : $homephone,
					 	   'mobile' => empty($mobile)? ' ' : $mobile,
					 	   'objectClass' => 'inetOrgPerson'
			);
			$location= 'cn='.$info['cn'].','.$location;
			$res = $conn->add($location, $info);
			foreach ($info as $key => $val)
				$str_info .= $key.': '.$val.' ';
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Update Error').
				' [%d]: %s<br/>dn: %s<br/>info: %s',
				$res->getCode(),$res->getMessage(),
				$location,
				$str_info
				));
			else {
?>
      			<br/>
				<div style="text-align: center;">
					<h2><?php echo _('Address Book updated');?></h2>
					<a href="<?php echo $PHP_SELF ?>" style="font-size: 1.3em" target="_self"><?php echo _('Return');?></a>
				</div>
<?php
				$conn->close();
			}
		}
	}
	else if (isset($search)) {
		$conn = &new LdapInterface();
		$res = $conn->connect(
			$ldap_abook_user_prefs[$server]['host'],
			null,
			$ldap_abook_user_prefs[$server]['dn'],
			$ldap_abook_user_prefs[$server]['pwd']
		);
		if (LdapInterface::is_error($res)) 
			die(sprintf(_('Connect Error').
			' [%d]: %s<br/>host: %s<br/>dn: %s<br/>pwd: %s',
				$res->getCode(),$res->getMessage(),
				$ldap_abook_user_prefs[$server]['host'],
				$ldap_abook_user_prefs[$server]['dn'],
				$ldap_abook_user_prefs[$server]['pwd']
				));
		else {
			$location = 'ou='.
			$ldap_abook_user_prefs[$server]['abook'].','.
			$ldap_abook_user_prefs[$server]['dn'];
			$givenname = directory_string_convert($givenname, $server, 'LDAP');
			$sn = directory_string_convert($sn, $server, 'LDAP');
			if (!empty($givenname) && !empty($sn))
				$attr = '('.$type.'(cn='.$givenname.' '.$sn.')';
			else {
				if (!empty($givenname))
					$attr = '('.$type.'(givenname='.$givenname.')';
				if (!empty($sn))
					empty($attr)? $attr = '('.$type.'(sn='.$sn.')' :
					$attr .= '(sn='.$sn.')';
			}
			if (!empty($mail))
				empty($attr)? $attr = '('.$type.'(mail='.$mail.')' :
				$attr .= '(mail='.$mail.')';
			if (!empty($homephone))
				empty($attr)? $attr = '('.$type.'(homephone='.$homephone.')' :
				$attr .= '(homephone='.$homephone.')';
			if (!empty($mobile))
				empty($attr)? $attr = '('.$type.'(mobile='.$mobile.')' :
				$attr .= '(mobile='.$mobile.')';
			empty($attr)? $attr = '(cn=*)' : $attr .= ')';
			$res = $conn->search($location, $attr);
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Search Error').
				' [%d]: %s<br/>location: %s<br/>attr: %s<br/>',
					$res->getCode(),$res->getMessage(),
					$location, $attr));
			$conn->output_short($server, $location, $res, $order);
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Output Error').
				' [%d]: %s<br/>location: %s<br/>resource: %s',
					$res->getCode(),$res->getMessage(),
					$location,$res));
			$conn->close();
		}
	}
	bindtextdomain('squirrelmail', SM_PATH . 'locale');
	textdomain('squirrelmail');
?>
</body>
</html>
