<?php
	
/*******************************************************************/
/* Various forms to use for user input                             */
/*******************************************************************/

	define ('SM_PATH','../../');
	include_once (SM_PATH . 'functions/i18n.php');
	
	include_once (SM_PATH . 'plugins/ldap_abook/config.php');

	function searchForm() {
		global $ldap_abook_user_prefs, $PHP_SELF;

		print '<form action="'.$PHP_SELF.'" method="post">';
		print _('Address book').': <select name="server">';
		$i = 0;
		foreach($ldap_abook_user_prefs as $pref) {
			print '<option value="'.$i.'">'.$pref['abook'].','.$pref['dn'].'</option>';
			$i++;
		}
?>
		</select><br/><br/>
		<table bgcolor="lightgray" align="center" cellspacing="2" cellpadding="5">
		<tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Given Name');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><input type="text" size="40" name="givenname" /></td>
		</tr><tr>
		<tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Family Name');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><input type="text" size="40" name="sn" /></td>
		</tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Email');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><input type="text" size="40" name="mail" /></td>
		</tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Home Phone');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><input type="text" size="40" name="homephone" /></td>
		</tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Mobile Phone');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><input type="text" size="40" name="mobile" /></td>
		</tr><tr>
		<td colspan="2" style="text-align: center; font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
			<?php echo _('Search type');?>:&nbsp;&nbsp;
			<input type="radio" name="searchType" value="&" checked="checked" />
			&nbsp;<?php echo _('AND');?>&nbsp;
			<input type="radio" name="searchType" value="|" />&nbsp;<?php echo _('OR');?>
		</td></tr>
		<tr>
		<td colspan="2" style="text-align: center; font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
			<?php echo _('Sort order');?>:&nbsp;&nbsp;
			<input type="radio" name="searchOrder" value="false" />
			&nbsp;<?php echo _('None');?>&nbsp;
			<input type="radio" name="searchOrder" value="ASC" checked="checked" />
			&nbsp;<?php echo _('a..Z');?>&nbsp;
			<input type="radio" name="searchOrder" value="DESC" />&nbsp;<?php echo _('Z..a');?>
		</td></tr>
		<tr>
		<td colspan="2" style="text-align: center; font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
			<input type="submit" name="search" value="<?php echo _('Search');?>" />
		</td></tr>
		</table>
	</form>
<?php
	}

	function inputForm($todo, $server, $dn) {
		global $ldap_abook_user_prefs, $PHP_SELF;

		switch (strtolower($todo)) {
			case 'delete':
				$buttonText = _('Delete');
				break;
			case 'new':
				$buttonText = _('New');
				break;
			case 'modify':
				$buttonText = _('Modify');
				break;
		}
		if ($todo != 'new') {
			$conn = &new LdapInterface();
			$res = $conn->connect(
				$ldap_abook_user_prefs[$server]['host'],
				null,
				$ldap_abook_user_prefs[$server]['dn'],
				$ldap_abook_user_prefs[$server]['pwd']
			);
			if (LdapInterface::is_error($res)) 
				die(sprintf(_('Connect Error').
				' [%d]: %s<br/>host: %s<br/>dn: %s<br/>pwd: %s',
					$res->getCode(),$res->getMessage(),
					$ldap_abook_user_prefs[$server]['host'],
					$ldap_abook_user_prefs[$server]['dn'],
					$ldap_abook_user_prefs[$server]['pwd']
				));
			else {
				$attr = '(cn=*)';
				$res = $conn->search($dn, $attr);
				if (LdapInterface::is_error($res)) 
					die(sprintf(_('Search Error').
					' [%d]: %s<br/>location: %s<br/>attr: %s<br/>',
						$res->getCode(),$res->getMessage(),
						$dn, $attr));
				$info = ldap_get_entries($conn->connection, $res);
				$info[0]['givenname'][0] = 
					directory_string_convert($info[0]['givenname'][0],
					$server, 'SM');
				$info[0]['sn'][0] =
				directory_string_convert($info[0]['sn'][0],
				$server, 'SM');
			}
		}
		echo '<h2 style="text-align: center;">'.ucwords($todo).' '._('Entry').'<h2>';
?>
		<form action="<?php echo $PHP_SELF;?>" method="post">
		<table bgcolor="lightgray" align="center" cellspacing="2" cellpadding="5">
		<tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><span style="color: red;">*</span><?php echo _('Given Name');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<input type="text" size="40" name="givenname" 
		value="<?php print (($todo == 'new')? '': $info[0]['givenname'][0]);?>"/>
		</td></tr><tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<span style="color: red;">*</span>
		<?php echo _('Family Name');?>
		</td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<input type="text" size="40" name="sn"
		value="<?php print (($todo == 'new')? '': $info[0]['sn'][0]);?>" /></td></tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<?php echo _('Email');?>
		</td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<input type="text" size="40" name="mail"
		value="<?php print (($todo == 'new')? '': $info[0]['mail'][0]);?>" />
		</td></tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Home Phone');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<input type="text" size="40" name="homephone"
		value="<?php print (($todo == 'new')? '': $info[0]['homephone'][0]);?>" />
		</td></tr><tr>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><?php echo _('Mobile Phone');?></td>
		<td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
		<input type="text" size="40" name="mobile"
		value="<?php print (($todo == 'new')? '': $info[0]['mobile'][0]);?>" />
		</td></tr><tr>
		<td colspan="2" style="text-align: center; font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
			<input type="submit" name="<?php echo $todo;?>" value="<?php echo $buttonText;?>" />
		</td></tr>
		</table>
		<input type="hidden" value="<?php echo $server;?>" name="server" />
		<input type="hidden" value="<?php echo $dn;?>" name="dn" />
		</form>
<?php
	}

?>
