<?php
/***************************************************************/
/* Helper functions for ldap_abook                             */
/***************************************************************/

	define ('SM_PATH','../../');
	include_once (SM_PATH . 'include/validate.php');
	include_once(SM_PATH . 'functions/i18n.php');
	
	include_once (SM_PATH . 'plugins/ldap_abook/config.php');

	function getDisplayPageHeader($pulldown) { 
		global $color;

		bindtextdomain('squirrelmail', SM_PATH . 'locale');
		textdomain('squirrelmail');
		displayPageHeader($color, $pulldown);
		bindtextdomain('ldap_abook', SM_PATH . 'plugins/ldap_abook/locale');
		textdomain('ldap_abook');
	}
	
	function ldap_abook_loadPrefs() {
		global $data_dir, $username, $ldap_abook_user_prefs;

		$size = getPref($data_dir, $username, 'ldap_abook_user_prefs_count_hosts');
		if (empty($size))
			return false;
		else {
			for ($i = 0; $i < $size; $i++) {
				$ldap_abook_user_prefs[$i]['dn'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_dn');
				$ldap_abook_user_prefs[$i]['host'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_host');
				$ldap_abook_user_prefs[$i]['uid'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_uid');
				$ldap_abook_user_prefs[$i]['pwd'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_pwd');
				$ldap_abook_user_prefs[$i]['abook'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_abook');
				$ldap_abook_user_prefs[$i]['charset'] = getPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_charset');
			}
			return true;
		}
	}

   function ldap_abook_deletePrefs($entry) {
	  global $data_dir, $username, $ldap_abook_user_prefs;

	  $size = getPref($data_dir, $username, 'ldap_abook_user_prefs_count_hosts') - 1;
      removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'_dn', $ldap_abook_user_prefs[$size]['dn']);
      removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'_host', $ldap_abook_user_prefs[$size]['host']);
      removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'_uid', $ldap_abook_user_prefs[$size]['uid']);
      removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'_pwd', $ldap_abook_user_prefs[$size]['pwd']);
      removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'_abook', $ldap_abook_user_prefs[$size]['abook']);
	  removePref($data_dir, $username, 'ldap_abook_user_prefs_'.$size.'-charset', $ldap_abook_user_prefs[$size]['charset']);
	  unset($ldap_abook_user_prefs[$entry]);
	  $i = 0;
	  foreach ($ldap_abook_user_prefs as $elem)
	  	$tmp[$i++] = $elem;
	  $ldap_abook_user_prefs = $tmp;
      ldap_abook_setPrefs();		
   }
   
   function ldap_abook_setPrefs() {
      global $data_dir, $username, $ldap_abook_user_prefs;
   
	  for ($i = 0; $i < count($ldap_abook_user_prefs); $i++) {
      	    setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_dn', $ldap_abook_user_prefs[$i]['dn']);
      	    setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_host', $ldap_abook_user_prefs[$i]['host']);
      	    setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_uid', $ldap_abook_user_prefs[$i]['uid']);
      	    setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_pwd', $ldap_abook_user_prefs[$i]['pwd']);
      	    setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_abook', $ldap_abook_user_prefs[$i]['abook']);
			setPref($data_dir, $username, 'ldap_abook_user_prefs_'.$i.'_charset', $ldap_abook_user_prefs[$i]['charset']);
	  }
      setPref($data_dir, $username, 'ldap_abook_user_prefs_count_hosts', $i);
   }

   function ldap_abook_getPrefs() {
	   global $username, $ldap_server, $ldap_abook_user_prefs;
	   
	   sqgetGlobalVar('server', $server, SQ_FORM);
	   sqgetGlobalVar('uid', $post_uid, SQ_FORM);
	   sqgetGlobalVar('pwd', $post_pwd, SQ_FORM);
	   sqgetGlobalVar('abook', $post_abook, SQ_FORM);
	   sqgetGlobalVar('charset', $post_charset, SQ_FORM);

	   (isset($post_uid) && !empty($post_uid))? $uid = $post_uid : $uid = $username;
	   (isset($post_pwd) && !empty($post_pwd))? $pwd = $post_pwd : $pwd = '';
	   (isset($post_abook) && !empty($post_abook))? $abook = $post_abook : $abook = 'contacts';
	   (isset($post_charset) && !empty($post_charset))? $charset = $post_charset : $charset = 'utf-8';
       $ldap_abook_user_prefs[] = array(
          'dn' => 'uid=' . $uid . ',' . $ldap_server[$_POST['server']]{'base'},
		  'host' => $ldap_server[$_POST['server']]{'host'},
          'uid' => $uid,
		  'pwd' => $pwd,
		  'abook' => $abook,
		  'charset' => $charset
		 );
   }

    /**
     * Convert character set of a string.
     * @param string $string String to convert.
	 * @param string $server current LDAP server.
	 * @param string $way to/from SM charset.
     * @return string Converted string.
     * Part of this function is copyright (c) 1999-2003
	 * Alexandros Vellis. Licensed under GNU GPL.
	 * My contribution was to make awere of default
	 * charset in Squirrelmail.
     */

    function directory_string_convert($string, $server, $way) {
    global $default_charset, $ldap_abook_user_prefs;
	
		switch ($way) {
			case 'LDAP':
				$from_charset = $default_charset;
				$to_charset = $ldap_abook_user_prefs[$server]['charset'];
				break;
			case 'SM':
				$to_charset = $default_charset;
				$from_charset = $ldap_abook_user_prefs[$server]['charset'];
				break;
		}
		
		if(strcasecmp($from_charset, $to_charset) == 0 ) {
   		   	return $string;
		}
	
		if(function_exists("mb_convert_encoding")) {
   	    	return mb_convert_encoding($string, $to_charset, $from_charset);
		} else if(function_exists("iconv")) {
   	    	return iconv($from_charset, $to_charset, $string);
		} else {
   	    	return $string;
		}
    }   

  function array_rm_dupes($arg_array, $is_sorted = false)
  {
    if (!$is_sorted)
      sort($arg_array, SORT_REGULAR);
    if (count($arg_array) > 1)
    {
      $res = array($last = $arg_array[0]);
      for ($i = 1; $i < count($arg_array); $i++)
      {
        if (!((string) $arg_array[$i] === (string) $last))
        {
          array_push($res, $arg_array[$i]);
          $last = $arg_array[$i];
        }
      }
      return $res;
    } else
      return $arg_array;
  } 
?>
