<?php
   /* ldap_abook options hooks
    *
    */

   /* Path for SquirrelMail required files. */
   define('SM_PATH','../../');

   /* SquirrelMail required files. */
   include_once(SM_PATH . 'include/validate.php');
   include_once(SM_PATH . 'functions/i18n.php');
   
   include_once(SM_PATH . 'plugins/ldap_abook/ldap_util.php');
   include_once(SM_PATH . 'plugins/ldap_abook/config.php');

   bindtextdomain('ldap_abook', SM_PATH . 'plugins/ldap_abook/locale');
   textdomain('ldap_abook');

   global $lda_charsets;
   
   getDisplayPageHeader(_('Address Book setup'));
	sqgetGlobalVar('PHP_SELF', $PHP_SELF, SQ_SERVER);
	sqgetGlobalVar('submit', $submit, SQ_FORM);
	sqgetGlobalVar('new', $new, SQ_FORM);
	sqgetGlobalVar('delete', $delete, SQ_FORM);

   if (ldap_abook_loadPrefs() && !isset($submit) && $new != 'true' && !isset($delete)) {
?>
      <br/>
      <h2 style="text-align: center;"><?php echo _('I will use these preferences');?></h2>
      <table bgcolor="lightgray" align="center" cellspacing="2" cellpadding="5">
      <tr>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('DN');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Host');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Username');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Password');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Book');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Charset');?></th>
	  <th style="color: black;background-color: #DAF9FF;">&nbsp;</th>
      </tr>
<?php
      global $ldap_abook_user_prefs, $ldap_server;

      for($i = 0; $i < count($ldap_abook_user_prefs); $i++) {
		 print '<tr><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['dn'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['host'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['uid'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['pwd'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['abook'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">'.
		 $ldap_abook_user_prefs[$i]['charset'].
		 '</td><td style="font-size: 0.8em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;"><a href="'.
		 $PHP_SELF.'?delete='.$i.'">'.
		 _('Delete').'</a></td></tr>';
	  }
?>
      </table>
      <br/>
      <div style="text-align: center;">
	  <a href="<?php echo SM_PATH ?>src/options.php" style="font-size: 1.3em"><?php echo _('Use values');?></a>
	  <a href="<?php $PHP_SELF ?>?new=true" style="font-size: 1.3em"><?php echo _('New values');?></a>
	  </div>
<?php
   }
   else if (isset($submit) && $new != 'true') {
	  ldap_abook_getPrefs();
      ldap_abook_setPrefs();
?>
      <br/>
      <div style="text-align: center;">
	  <h2><?php echo _('Preferences loaded');?></h2>
	  <a href="<?php echo SM_PATH ?>src/options.php" style="font-size: 1.3em"><?php echo _('Return');?></a>
	  </div>
<?php
   }
   else if (isset($delete)) {
	   ldap_abook_deletePrefs($delete);
?>
      <br/>
      <div style="text-align: center;">
	  <h2><?php echo _('Preferences updated');?></h2>
	  <a href="<?php echo SM_PATH ?>src/options.php" style="font-size: 1.3em"><?php echo _('Return');?></a>
	  </div>
<?php
	}
   else {
?>
   <br>
     <form action="<?php echo $PHP_SELF?>" method="post">
     <?php echo _('Base DN');?>:
      <select name="server">      	
<?php
      $i = 0;
      foreach ($ldap_server as $server) {
			print '<option value="'.$i.'"';
            print ($i == 0)? ' selected="selected">': '">';
            print $server['base'].'</option>';
			$i++;
	  }
?>
      </select>
      <br/>
	  <br/>
      <table bgcolor="lightgray" align="center" cellspacing="2" cellpadding="5">
      <tr>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Option');?></th>
      <th style="color: black;background-color: #DAF9FF;"><?php echo _('Value');?></th>
      </tr>
      <tr>
      <td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <?php echo _('Name of address book');?></td>
      <td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <input type="text" name="abook" /></td></tr>
	  <tr><td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <?php echo _('Your password');?></td>
      <td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <input type="password" name="pwd" /></td></tr>
	  <tr><td colspan="2" style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
	  <?php echo _('the next option is optional - I will use your current username');?></td></tr>
	  </tr><td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <?php echo _('Username');?></td>
      <td style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <input type="text" name="uid" /></td></tr>
	  <tr><td align="center" colspan="2" style="font-size: 1.3em;font-family: verdana times san-serif;color: navy;background-color: #FFF693;">
         <input type="submit" name="submit" value="<?php echo _('Submit');?>" /></td></tr>
      </table>
	  <br/>
	  <?php echo _('Charset');?>:
   	  <select name="charset">
	 
<?php
	     foreach ($lda_charsets as $charset) {
			 print '<option value="'.$charset.'"';
			 if ($charset == 'utf-8')
			 	print ' selected="selected">';
			 else
			 	print '>';
			 print $charset.'</option>';
		}
?>
	</select>
	</form>
<?php
   }
 bindtextdomain('squirrelmail', SM_PATH . 'locale');
 textdomain('squirrelmail');
?>
</body></html>
